Index: uspace/app/terminal/terminal.h
===================================================================
--- uspace/app/terminal/terminal.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/terminal/terminal.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * Copyright (c) 2012 Petr Koupy
  * All rights reserved.
@@ -38,5 +38,7 @@
 #define TERMINAL_H
 
+#include <adt/prodcons.h>
 #include <errno.h>
+#include <fibril.h>
 #include <fibril_synch.h>
 #include <gfx/bitmap.h>
@@ -46,7 +48,7 @@
 #include <io/con_srv.h>
 #include <loc.h>
-#include <adt/prodcons.h>
 #include <stdatomic.h>
 #include <str.h>
+#include <task.h>
 #include <ui/ui.h>
 #include <ui/window.h>
@@ -89,10 +91,14 @@
 	charfield_t *ubuf;
 
+	loc_srv_t *srv;
 	service_id_t dsid;
 	con_srvs_t srvs;
+
+	task_wait_t wait;
+	fid_t wfid;
 } terminal_t;
 
 extern errno_t terminal_create(const char *, sysarg_t, sysarg_t,
-    terminal_flags_t, terminal_t **);
+    terminal_flags_t, const char *, terminal_t **);
 extern void terminal_destroy(terminal_t *);
 
Index: uspace/app/tester/console/console1.c
===================================================================
--- uspace/app/tester/console/console1.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/tester/console/console1.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -106,5 +106,5 @@
 		}
 		console_flush(console);
-		console_set_color(console, COLOR_WHITE, COLOR_BLACK, 0);
+		console_set_style(console, STYLE_NORMAL);
 		putchar('\n');
 
@@ -115,5 +115,5 @@
 		}
 		console_flush(console);
-		console_set_color(console, COLOR_WHITE, COLOR_BLACK, 0);
+		console_set_style(console, STYLE_NORMAL);
 		putchar('\n');
 
Index: uspace/app/tester/fault/fault1.c
===================================================================
--- uspace/app/tester/fault/fault1.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/tester/fault/fault1.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -30,4 +30,6 @@
 #include "../tester.h"
 
+#pragma GCC diagnostic ignored "-Warray-bounds"
+
 const char *test_fault1(void)
 {
Index: uspace/app/tester/ipc/readwrite.c
===================================================================
--- uspace/app/tester/ipc/readwrite.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/tester/ipc/readwrite.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,126 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <as.h>
+#include <errno.h>
+#include <mem.h>
+#include <stdint.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <ipc_test.h>
+#include "../tester.h"
+
+enum {
+	rw_buf_size = 1024
+};
+
+static uint8_t rw_buf[rw_buf_size];
+
+const char *test_readwrite(void)
+{
+	ipc_test_t *test = NULL;
+	size_t i;
+	errno_t rc;
+
+	rc = ipc_test_create(&test);
+	if (rc != EOK)
+		return "Error contacting IPC test service.";
+
+	rc = ipc_test_set_rw_buf_size(test, rw_buf_size);
+	if (rc != EOK)
+		return "Error getting read-only area size.";
+
+	/*
+	 * Write all zeroes to remote buffer
+	 */
+	memset(rw_buf, 0x00, rw_buf_size);
+	rc = ipc_test_write(test, rw_buf, rw_buf_size);
+	if (rc != EOK)
+		return "Error writing remote buffer.";
+
+	TPRINTF("Successfully wrote zeroes to remote buffer.\n");
+
+	/*
+	 * Read back contents of remote buffer and verify
+	 */
+
+	/*
+	 * Make sure the contents of local buffer are different from what
+	 * we expect to read.
+	 */
+	memset(rw_buf, 0xff, rw_buf_size);
+	rc = ipc_test_read(test, rw_buf, rw_buf_size);
+	if (rc != EOK)
+		return "Error reading remote buffer.";
+
+	TPRINTF("Successfully read back remote buffer.\n");
+
+	/* Now verify what we have read */
+	for (i = 0; i < rw_buf_size; i++) {
+		if (rw_buf[i] != 0x00)
+			return "Failed verification of read data.";
+	}
+
+	TPRINTF("Read data succeeded verification.\n");
+
+	/*
+	 * Write all binary ones to remote buffer
+	 */
+	memset(rw_buf, 0xff, rw_buf_size);
+	rc = ipc_test_write(test, rw_buf, rw_buf_size);
+	if (rc != EOK)
+		return "Error writing remote buffer.";
+
+	TPRINTF("Successfully wrote binary ones to remote buffer.\n");
+
+	/*
+	 * Read back contents of remote buffer and verify
+	 */
+
+	/*
+	 * Make sure the contents of local buffer are different from what
+	 * we expect to read.
+	 */
+	memset(rw_buf, 0x00, rw_buf_size);
+	rc = ipc_test_read(test, rw_buf, rw_buf_size);
+	if (rc != EOK)
+		return "Error reading remote buffer.";
+
+	TPRINTF("Successfully read back remote buffer.\n");
+
+	/* Now verify what we have read */
+	for (i = 0; i < rw_buf_size; i++) {
+		if (rw_buf[i] != 0xff)
+			return "Failed verification of read data.";
+	}
+
+	TPRINTF("Read data succeeded verification.\n");
+
+	ipc_test_destroy(test);
+	return NULL;
+}
Index: uspace/app/tester/ipc/readwrite.def
===================================================================
--- uspace/app/tester/ipc/readwrite.def	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/tester/ipc/readwrite.def	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,6 @@
+{
+	"readwrite",
+	"IPC read/write test",
+	&test_readwrite,
+	true
+},
Index: uspace/app/tester/meson.build
===================================================================
--- uspace/app/tester/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/tester/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2021 Jiri Svoboda
+# Copyright (c) 2023 Jiri Svoboda
 # Copyright (c) 2005 Martin Decky
 # Copyright (c) 2007 Jakub Jermar
@@ -29,5 +29,5 @@
 #
 
-deps = [ 'block', 'codepage', 'drv', 'math' ]
+deps = [ 'block', 'codepage', 'drv', 'math', 'ipctest', 'console' ]
 src = files(
 	'tester.c',
@@ -52,4 +52,5 @@
 	'float/float2.c',
 	'vfs/vfs1.c',
+	'ipc/readwrite.c',
 	'ipc/sharein.c',
 	'ipc/starve.c',
Index: uspace/app/tester/mm/common.c
===================================================================
--- uspace/app/tester/mm/common.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/tester/mm/common.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -35,4 +35,5 @@
 #include <stdlib.h>
 #include <errno.h>
+#include <malloc.h>
 #include "../tester.h"
 #include "common.h"
Index: uspace/app/tester/print/print5.c
===================================================================
--- uspace/app/tester/print/print5.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/tester/print/print5.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -38,4 +38,5 @@
  */
 #pragma GCC diagnostic ignored "-Wformat"
+#pragma GCC diagnostic ignored "-Wformat-overflow"
 
 #include <stdio.h>
Index: uspace/app/tester/tester.c
===================================================================
--- uspace/app/tester/tester.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/tester/tester.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -68,4 +68,5 @@
 #include "float/float2.def"
 #include "vfs/vfs1.def"
+#include "ipc/readwrite.def"
 #include "ipc/sharein.def"
 #include "ipc/starve.def"
Index: uspace/app/tester/tester.h
===================================================================
--- uspace/app/tester/tester.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/tester/tester.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -99,4 +99,5 @@
 extern const char *test_vfs1(void);
 extern const char *test_ping_pong(void);
+extern const char *test_readwrite(void);
 extern const char *test_sharein(void);
 extern const char *test_starve_ipc(void);
Index: uspace/app/tetris/meson.build
===================================================================
--- uspace/app/tetris/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/tetris/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -28,4 +28,5 @@
 #
 
+deps = [ 'console' ]
 src = files(
 	'shapes.c',
Index: uspace/app/tetris/scores.c
===================================================================
--- uspace/app/tetris/scores.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/tetris/scores.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -149,4 +149,7 @@
 			continue;
 
+		if ((ev.ev.key.mods & (KM_CTRL | KM_ALT)) != 0)
+			continue;
+
 		kev = &ev.ev.key;
 
Index: uspace/app/top/meson.build
===================================================================
--- uspace/app/top/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/top/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -28,4 +28,5 @@
 #
 
+deps = [ 'console' ]
 src = files(
 	'top.c',
Index: uspace/app/trace/ipcp.c
===================================================================
--- uspace/app/trace/ipcp.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/trace/ipcp.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -92,5 +92,5 @@
 }
 
-static hash_table_ops_t pending_call_ops = {
+static const hash_table_ops_t pending_call_ops = {
 	.hash = pending_call_hash,
 	.key_hash = pending_call_key_hash,
Index: uspace/app/trace/meson.build
===================================================================
--- uspace/app/trace/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/trace/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -28,4 +28,5 @@
 #
 
+deps = [ 'console' ]
 src = files(
 	'trace.c',
Index: uspace/app/trace/proto.c
===================================================================
--- uspace/app/trace/proto.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/trace/proto.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -76,5 +76,5 @@
 }
 
-static hash_table_ops_t srv_proto_ops = {
+static const hash_table_ops_t srv_proto_ops = {
 	.hash = srv_proto_hash,
 	.key_hash = srv_proto_key_hash,
@@ -103,5 +103,5 @@
 }
 
-static hash_table_ops_t method_oper_ops = {
+static const hash_table_ops_t method_oper_ops = {
 	.hash = method_oper_hash,
 	.key_hash = method_oper_key_hash,
